#include <windows.h>
#include "hsp3win.h"
#include "spimain.h"
#include "hsp3spi.h"
#include "../hsp3code.h"

int *type = (int*)0;
int *val = (int*)0;
HSPCTX *ctx = (HSPCTX*)0;
HSPEXINFO *exinfo = (HSPEXINFO*)0;
static int ref_ival = 0;
static void *ptr = NULL;

unsigned short *lbGetPluginInfo = NULL;
unsigned short *lbIsSupported = NULL;
unsigned short *lbGetPictureInfo = NULL;
unsigned short *lbGetPicture = NULL;
unsigned short *lbGetPreview = NULL;
unsigned short *lbDllFree = NULL;

int hsp3spi_init(HINSTANCE hInstance,char *startfile)
{
	int res;
	res = hsp3win_init(hInstance,startfile);
	hsp3typeinit_spicmd(code_gettypeinfo(TYPE_SPICMD));
	return res;//
}

void hsp3typeinit_spicmd(HSP3TYPEINFO *info)
{
	info->cmdfunc = cmdfunc_spicmd;
	info->reffunc = reffunc_spicmd;
	ctx = info->hspctx;
	exinfo = info->hspexinfo;
	type = exinfo->nptype;
	val = exinfo->npval;//
}

static int cmdfunc_spicmd(int cmd)
{
	code_next();
	switch ( cmd )
	{
	case 0x000:
		//spiset_GetPluginInfo
		lbGetPluginInfo = code_getlb();
		break;
	case 0x001:
		//spiset_IsSupported
		lbIsSupported = code_getlb();//
		break;
	case 0x002:
		//spiset_GetPictureInfo
		lbGetPictureInfo = code_getlb();//
		break;
	case 0x003:
		//spiset_GetPicture
		lbGetPicture = code_getlb();//
		break;
	case 0x004:
		//spiset_GetPreview
		lbGetPreview = code_getlb();//
		break;
	case 0x005:
		//spiset_DllFree
		lbDllFree = code_getlb();//
		break;
		//
	default:
		throw HSPERR_UNSUPPORTED_FUNCTION;
	}
	code_next();
	return RUNMODE_RUN;
}

static void* reffunc_spicmd(int *type_res,int cmd)
{
	switch( cmd>>7 ) {
		case 2:
			*type_res = HSPVAR_FLAG_STR;
			ptr = NULL;
			break;
		default:
			*type_res = HSPVAR_FLAG_INT;
			ptr = &ref_ival;
			break;
	}

	switch (cmd)
	{
	case 0x000:
		//spiget_infono
		ref_ival = _infono;
		//
		break;
	case 0x001:
		//spiget_buf
		ref_ival = (int)_buf;
		//
		break;
	case 0x002:
		//spiget_buflen
		ref_ival = _buflen;
		//
		break;
	case 0x003:
		//spiget_filename
		ref_ival = (int)_filename;
		//
		break;
	case 0x004:
		//spiget_dw
		ref_ival = (int)_dw;
		//
		break;
	case 0x005:
		//spiget_len
		ref_ival = (int)_len;
		//
		break;
	case 0x006:
		//spiget_flag
		ref_ival = (unsigned int)_flag;
		//
		break;
	case 0x007:
		//spiget_lpInfo
		ref_ival = (int)_lpInfo;
		//
		break;
	case 0x008:
		//spiget_pHBInfo
		ref_ival = (int)_pHBInfo;
		//
		break;
	case 0x009:
		//spiget_pHBm
		ref_ival = (int)_pHBm;
		//
		break;
	case 0x00a:
		//spiget_lpPrgressCallback
		ref_ival = (int)_lpPrgressCallback;
		//
		break;
	case 0x00b:
		//spiget_lData
		ref_ival = (int)_lData;
		//
		break;
		//
	default:
		throw HSPERR_UNSUPPORTED_FUNCTION;
	}
	//
	return ptr;
}

void spi_init()
{
	code_call(ctx->mem_mcs);//
}